3v4l.org

run code in 150+ php & hhvm versions
Bugs & Features
<?php function call_user_func_fixed() { // Not much point in writing all that logic out twice, just require that both fixer functions are present $args = func_get_args(); $callable = array_shift($args); return call_user_func_array_fixed($callable, $args); } function call_user_func_array_fixed($callable, $args) { $isStaticMethod = false; // Normalize the $callable and see if it looks like a static method if (is_object($callable) && $callable instanceof Closure) { $func = $callable; } else if (is_string($callable)) { $expr = '/^([a-z_\x7f-\xff][\w\x7f-\xff]*)::([a-z_\x7f-\xff][\w\x7f-\xff]*)$/i'; if (preg_match($expr, $callable, $matches)) { $func = array($matches[1], $matches[2]); $isStaticMethod = true; } else { $func = $callable; } } else if (is_array($callable) && isset($callable[0], $callable[1]) && count($callable) === 2) { if (is_object($callable[0])) { $func = $callable; } else if (is_string($callable[0])) { $func = $callable; $isStaticMethod = true; } } // If it's not a valid callable give up here if (!isset($callable) || (!$isStaticMethod && !is_callable($callable))) { trigger_error('call_user_func() expects parameter 1 to be a valid callback', E_USER_WARNING); return null; } // If it's not a static method use the regular mechanism if (!$isStaticMethod) { return call_user_func_array($func, $args); } // Get a reference to the target static method if possible try { if ($func[0] === 'self') { if (!$contextClass) { throw new Exception('Use of self in an invalid context'); } $class = new ReflectionClass($contextClass); $method = $class->getMethod($func[1]); if ($method->isPrivate()) { if ($method->getDeclaringClass()->getName() !== $contextClass || !method_exists($method, 'setAccessible')) { throw new Exception('Attempting to call private method in an invalid context'); } $method->setAccessible(true); } else if ($method->isProtected()) { if (!method_exists($method, 'setAccessible')) { throw new Exception('Attempting to call protected method in an invalid context'); } while ($class->getName() !== $contextClass) { $class = $class->getParentClass(); } if ($class->getName() !== $contextClass) { throw new Exception('Attempting to call protected method in an invalid context'); } $method->setAccessible(true); } } else if ($func[0] === 'static' && function_exists('get_called_class')) { $class = new ReflectionClass(get_called_class()); $method = $class->getMethod($func[1]); } else { $class = new ReflectionClass($func[0]); $method = $class->getMethod($func[1]); } // Invoke the method with the passed arguments and return the result return $method->invokeArgs(null, $args); } catch (Exception $e) { trigger_error('call_user_func*() expects parameter 1 to be a valid callback: ' . $e->getMessage(), E_USER_WARNING); return null; } // Invoke the method with the passed arguments and return the result return $method->invokeArgs(null, $args); } class Car { public function run() { return call_user_func_fixed('self::getName'); // should call toyota } private static function getName() { return 'Car'; } } class Toyota extends Car { public static function getName() { return 'Toyota'; } } $car = new Car(); echo $car->run(); //Car instead of Toyota $toyota = new Toyota(); echo $toyota->run(); //Car instead of Toyota
Output for 5.0.4 - 5.0.5, 5.1.1 - 7.1.0
Notice: Undefined variable: contextClass in /in/BYIV2 on line 50 Warning: call_user_func*() expects parameter 1 to be a valid callback: Use of self in an invalid context in /in/BYIV2 on line 89 Notice: Undefined variable: contextClass in /in/BYIV2 on line 50 Warning: call_user_func*() expects parameter 1 to be a valid callback: Use of self in an invalid context in /in/BYIV2 on line 89
Output for 5.1.0
Fatal error: fatal flex scanner internal error--end of buffer missed in /in/BYIV2 on line 116
Process exited with code 255.
Output for 5.0.0 - 5.0.3
Notice: Undefined variable: contextClass in /in/BYIV2 on line 50 Warning: call_user_func*() expects parameter 1 to be a valid callback: Use of self in an invalid context in /in/BYIV2 on line 89 Notice: Undefined variable: contextClass in /in/BYIV2 on line 50 Warning: call_user_func*() expects parameter 1 to be a valid callback: Use of self in an invalid context in /in/BYIV2 on line 89
Output for 4.4.2 - 4.4.9
Parse error: syntax error, unexpected T_STRING in /in/BYIV2 on line 17
Process exited with code 255.
Output for 4.3.0 - 4.3.1, 4.3.5 - 4.4.1
Parse error: parse error, unexpected T_STRING in /in/BYIV2 on line 17
Process exited with code 255.
Output for 4.3.2 - 4.3.4
Parse error: parse error in /in/BYIV2 on line 17
Process exited with code 255.